/* GNIO - GLib Network Layer of GIO
 *
 * Copyright (C) 2008 Christian Kellner, Samuel Cormier-Iijima
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General
 * Public License along with this library; if not, write to the
 * Free Software Foundation, Inc., 59 Temple Place, Suite 330,
 * Boston, MA 02111-1307, USA.
 *
 * Authors: Christian Kellner <gicmo@gnome.org>
 *          Samuel Cormier-Iijima <sciyoshi@gmail.com>
 */

#ifndef G_SOCKET_H
#define G_SOCKET_H

#include <glib-object.h>
#include <gio/gio.h>

#include "ginetaddress.h"

G_BEGIN_DECLS

#define G_TYPE_SOCKET         (g_socket_get_type ())
#define G_SOCKET(o)           (G_TYPE_CHECK_INSTANCE_CAST ((o), G_TYPE_SOCKET, GSocket))
#define G_SOCKET_CLASS(k)     (G_TYPE_CHECK_CLASS_CAST((k), G_TYPE_SOCKET, GSocketClass))
#define G_IS_SOCKET(o)        (G_TYPE_CHECK_INSTANCE_TYPE ((o), G_TYPE_SOCKET))
#define G_IS_SOCKET_CLASS(k)  (G_TYPE_CHECK_CLASS_TYPE ((k), G_TYPE_SOCKET))
#define G_SOCKET_GET_CLASS(o) (G_TYPE_INSTANCE_GET_CLASS ((o), G_TYPE_SOCKET, GSocket))

typedef struct _GSocket        GSocket;
typedef struct _GSocketClass   GSocketClass;

struct _GSocket
{
  GObject parent;
};

struct _GSocketClass
{
  GObjectClass parent_class;
};

GType          g_socket_get_type (void) G_GNUC_CONST;

GSocket *      g_socket_new ();

void           g_socket_bind (GSocket *socket, GInetAddress *address);

GSocket *      g_socket_accept (GSocket *socket);

void           g_socket_accept_async (GSocket *socket);

GSocket *      g_socket_accept_finish (GSocket *socket);

void           g_socket_listen (GSocket *socket, int backlog);

G_END_DECLS

#endif /* G_SOCKET_H */

